package com.sleepycat.je.log;

import java.io.File;

import com.sleepycat.je.DatabaseException;
import com.sleepycat.je.dbi.EnvironmentImpl;

public aspect FileManagerExtension {
	/* group commit sync */
	private FSyncManager FileManager.syncManager;

	/**
	 * Flush a file using the group sync mechanism, trying to amortize off other
	 * syncs.
	 */
	void FileManager.groupSync() throws DatabaseException {

		syncManager.fsync();
	}

	after(FileManager fileManager, EnvironmentImpl envImpl) throws DatabaseException:
		execution(FileManager.new(EnvironmentImpl, File, boolean)) && this(fileManager) && args(envImpl,File,boolean) {
		fileManager.syncManager = new FSyncManager(envImpl);
	}



	
	
//	/**
//	 * Log this single object and force a write of the log files.
//	 * 
//	 * @param item
//	 *            object to be logged
//	 * @param fsyncRequired
//	 *            if true, log files should also be fsynced.
//	 * @return LSN of the new log entry
//	 */
//	public long LogManager.logForceFlush(LoggableObject item, boolean fsyncRequired)
//			throws DatabaseException {
//
//		return log(item, false, // is provisional
//				true, // flush required
//				fsyncRequired, 
//				false, // forceNewLogFile
//				DbLsn.NULL_LSN); // oldNodeLsn, for obsolete counting.
//	}
}
